///////////////////////////////////////////////////
//(c)2002 Erik Sjolander
//This code may be used and modified for non-profit, 
//educational purposes, as long as this copyright
//notice is preserved.  Any other use requires my 
//permission.  
//
//ad_test.c
//a test program for my a/d routines.  Uses the
//a/d library a_d.c
///////////////////////////////////////////////////

#include <io.h>
#include <interrupt.h>
#include "global.h"
#include "uart.h"
#include "a_d.h"


void delay(u16 delay_time) {
    do {
      u08 i=0;
      do {
      asm volatile("nop\n\t"
          "nop\n\t"
          "nop\n\t"
          "nop\n\t"
          ::);
      } while(--i);
    } while(--delay_time);
}

int main(void)
{
    DDRA = 0;    //all ports are inputs
    DDRB = 0;
    DDRC = 0; 
    DDRD = 0;
    
    uart_init();
    ad_init();
    
    //s16 analog7;
    char out[32];
    s16 ad_values[8];
    s16 ad_offsets[8];
    sei();  
    //uart_putstr("AD start\r\n");

    //make port D2 an input to check for button press
    SFIOR &= ~_BV(PUD); //enable the pull-up resistors
    PORTD |= _BV(2); //turn on pull-up for PD2
    delay(0xFF); //wait for pin to go high
    u08 i,j;
    /*
    while(PIND & _BV(2)){;} //wait for button press
    */
    //get_all_ad_avg(ad_offsets);
    //u08 j;
    //for(j=0; j<8; j++)
        //ad_offsets[j]-=1000;  //make sure all output values are positive
    //uart_putstr("Conversion start\r\n");
    u08 temp;
    
    
    
    for(;;)
    {
        get_all_ad_avg(ad_values);
        
        //u08 i;
        for(i=0; i<8; i++)
        {
            //ad_values[i] -= ad_offsets[i]; //do the offset
            sprintf(out, "AD%i:\t%i\r\n", i, ad_values[i]);
            uart_putstr(out);
        }
        temp = (PIND & _BV(2)) >> 2;
        sprintf(out, "D2:\t%i\r\n", temp);
        uart_putstr(out);
        temp = (PIND & _BV(7)) >> 7;
        sprintf(out, "D7:\t%i\r\n", temp);
        uart_putstr(out);
        temp = (PINC & 0x0F); //low bits are inputs
        sprintf(out, "C:\t%i\r\n", temp);
        uart_putstr(out);
        
        //sprintf(out, "PIND:\t%x\r\n",PIND);
        //uart_putstr(out);
        //analog7 = get_sample(7);
        //sprintf(out, "AD7:\t%i\r\n", analog7);
        //uart_putstr(out);
        delay(0x1FFF);
        uart_nl();
    }
}


