///////////////////////////////////////////////////
//(c)2002 Erik Sjolander
//This code may be used and modified for non-profit, 
//educational purposes, as long as this copyright
//notice is preserved.  Any other use requires my 
//permission.  
//
//bump_switches.c
//Behavior code that handles bump switches and
//edge-of-table sensors.    
///////////////////////////////////////////////////
#include "demo.h"
#include "global.h"
#include <io.h>
#include "motor.h"
#include "bump_switches.h"

void bump_switches_init()
{
    DDRC  &= ~(_BV(3)|_BV(2));  //set these pins as inputs
    PORTC |=   _BV(2)|_BV(3);    //enable pull-up resistors
}

void bump_switches(struct behavior* out) 
{
    s16 left_motor=MOTOR_STOP, right_motor=MOTOR_STOP;
    s08 confidence=-1;
    if(!(PINC & _BV(3))) {
        left_motor = MOTOR_BACKWARD_SLOW;
        confidence =100;
    }
    if(!(PINC & _BV(2))) {
        right_motor = MOTOR_BACKWARD_SLOW;
        confidence = 100;
    }
    if(ad_data[right_table] > 1010 || ad_data[left_table] > 1010) {
        left_motor = MOTOR_STOP;
        right_motor = MOTOR_STOP;
        confidence = 100;
    }
    
    
    out->confidence = confidence;
    out->left_motor = left_motor;
    out->right_motor = right_motor;
    out->acceleration = ACCELERATION_FAST;
}
