///////////////////////////////////////////////////
//(c)2002 Erik Sjolander
//This code may be used and modified for non-profit, 
//educational purposes, as long as this copyright
//notice is preserved.  Any other use requires my 
//permission.  
//
//glass_filling.c
//Code to fill a glass, when it is found.  The only
//of the 4 behaviors that does not return (this
//behavior takes over the robot until it completes).  
///////////////////////////////////////////////////
#include "demo.h"
#include "global.h"
#include <io.h>
#include "motor.h"
#include "glass_filling.h"


void glass_filling_init(void)
{

    DDRB  |= _BV(3);				//Set OC0 as output
    PORTB &= ~_BV(3);				//Turn off OC0
        
    OCR0  = 0x00;				//Make sure pin stays off
    
    TCCR0 = _BV(PWM0)|_BV(COM01)|_BV(CS01);    //enable timer 0 as PWM
}

void glass_filling(struct behavior* out)
{
    s16 left_motor = MOTOR_STOP, right_motor = MOTOR_STOP;
    s08 confidence = -1;
    //static s08 count = 0;
    if(ad_data[glass_detector] < 900) {
        //confidence = 60;
        set_acceleration(ACCELERATION_FAST);
        motor_speed(MOTOR_STOP, MOTOR_STOP);
        
        //count++;
        //if(count >1 ) {
            //fill the glass.,.
        if(PIND & _BV(7)) {
            PUMP_OCR = PUMP_RUN; //turns on pump
            while(PIND & _BV(7)) {;} //wait for glass to fill
            PUMP_OCR = 0; //turn off pump
        }
            
            //turn left to go around the glass
        //left_motor = MOTOR_BACKWARD_SLOW;
        //right_motor = MOTOR_FORWARD_SLOW;
        motor_speed(MOTOR_BACKWARD_SLOW, MOTOR_STOP);
        delay(0x1000);
        motor_speed(MOTOR_BACKWARD_SLOW, MOTOR_FORWARD_SLOW);
        //motor_speed(left_motor, right_motor);
        delay(0x2000);
        motor_speed(MOTOR_FORWARD_SLOW, MOTOR_FORWARD_SLOW);
        delay(0x1000);
        //}
        //do the glass filling here.........
        //remember the motors don't turn off until AFTER
        //the routine has run once    
        
    } else {
        //no glass found;
    }
    
    out->confidence = confidence;
    out->left_motor = left_motor;
    out->right_motor = right_motor;
    out->acceleration = ACCELERATION_FAST;

}
