//uart.h

#ifndef UART_H
#define UART_H

/* set baud rate here */
#define UART_BAUD_RATE 19200
#define ESC            0x1b
#define UART_BUF_SIZE    16
#define SCRATCH 16
#define F_CPU        6000000               /* 6MHz processor */


/* automatically calcuate baud register value */
#define UART_BAUD_SELECT (F_CPU/(UART_BAUD_RATE*16l)-1)


/* prototypes */
extern void uart_init(void);
extern void uart_clr(void);
extern void uart_nl(void);
extern bool uart_putchar(u08 c);
extern s16  uart_getchar(void);
extern bool uart_putstr(u08 s[]);
extern bool uart_putstr_fast(u08 s[]);
extern int sprintf(u08 *, const u08 *, ...);

#endif 
